## mingw-w64-openlibm-0.8.6-3.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25)

# Get version string from Make.inc
file(READ "${CMAKE_CURRENT_LIST_DIR}/Make.inc" MAKE_FILE)
string(REGEX MATCH "VERSION = ([0-9\.]+)" _ ${MAKE_FILE})

project(openlibm
        VERSION ${CMAKE_MATCH_1}
        LANGUAGES C ASM)

option(BUILD_SHARED_LIBS "Build using shared libraries" ON)

add_library("${PROJECT_NAME}")

# Find the relevant folder depending on the architecture
set(OPENLIBM_ARCH_FOLDER ${CMAKE_SYSTEM_PROCESSOR})
string(TOLOWER "${OPENLIBM_ARCH_FOLDER}" OPENLIBM_ARCH_FOLDER)

if(${OPENLIBM_ARCH_FOLDER} STREQUAL "amd64" OR ${OPENLIBM_ARCH_FOLDER} STREQUAL "x86_64")
    set(OPENLIBM_ARCH_FOLDER "amd64")
elseif(${OPENLIBM_ARCH_FOLDER} STREQUAL "arm64" OR ${OPENLIBM_ARCH_FOLDER} STREQUAL "aarch64")
    set(OPENLIBM_ARCH_FOLDER "aarch64")
elseif(${OPENLIBM_ARCH_FOLDER} STREQUAL "armv7-a")
    set(OPENLIBM_ARCH_FOLDER "arm")
elseif(${OPENLIBM_ARCH_FOLDER} STREQUAL "x86" OR ${OPENLIBM_ARCH_FOLDER} STREQUAL "i686")
    set(OPENLIBM_ARCH_FOLDER "i387")
elseif(${OPENLIBM_ARCH_FOLDER} STREQUAL "powerpc")
    set(OPENLIBM_ARCH_FOLDER "powerpc")
elseif(${OPENLIBM_ARCH_FOLDER} STREQUAL "riscv64")
    set(OPENLIBM_ARCH_FOLDER "riscv64")
else()
    message(FATAL_ERROR "${PROJECT_NAME} not set up for detected architecture: ${OPENLIBM_ARCH_FOLDER}")
endif()


# Compile flags
list(APPEND C_ASM_COMPILE_FLAGS "-ffp-contract=off" "-fno-fast-math" "-fno-rounding-math" "-fno-math-errno")
list(APPEND C_ASM_COMPILE_FLAGS "-fPIC" "-std=c99" "-fno-builtin")
list(APPEND C_ASM_COMPILE_FLAGS "-Wall" "-Wno-implicit-function-declaration")
list(APPEND C_ASM_COMPILE_FLAGS "-DASSEMBLER" "-D__BSD_VISIBLE" "-O3")

# Compiler-specific compile flags
if("${CMAKE_C_COMPILER_ID}" MATCHES "Clang")
    list(APPEND C_ASM_COMPILE_FLAGS "-fno-strict-aliasing" "-ffp-exception-behavior=strict")
elseif("${CMAKE_C_COMPILER_ID}" STREQUAL "GNU")
    list(APPEND C_ASM_COMPILE_FLAGS "-fno-gnu89-inline")
else()
    message(FATAL_ERROR "${PROJECT_NAME} not set up to be compiled with ${CMAKE_C_COMPILER_ID}")
endif()

# Architecture-specific compile flags - take advantage of sse on x86
if(${OPENLIBM_ARCH_FOLDER} STREQUAL "i387")
    list(APPEND C_ASM_COMPILE_FLAGS "-march=i686" "-m32" "-msse2" "-mfpmath=sse")
elseif(${OPENLIBM_ARCH_FOLDER} STREQUAL "amd64")
    list(APPEND C_ASM_COMPILE_FLAGS "-m64" "-msse2" "-mfpmath=sse")
endif()

# Suppress warnings if requested
if(OPENLIBM_SUPPRESS_WARNINGS)
    list(APPEND C_ASM_COMPILE_FLAGS "-w")
endif()

# Add compile flags
target_compile_options("${PROJECT_NAME}" PUBLIC ${C_ASM_COMPILE_FLAGS})

# Project Source
set(PROJECT_SRC "${CMAKE_CURRENT_SOURCE_DIR}")

# Common
list(APPEND OPENLIBM_C_SOURCE
        # src
        "${PROJECT_SRC}/src/common.c"
        "${PROJECT_SRC}/src/e_acos.c"
        "${PROJECT_SRC}/src/e_acosf.c"
        "${PROJECT_SRC}/src/e_acosh.c"
        "${PROJECT_SRC}/src/e_acoshf.c"
        "${PROJECT_SRC}/src/e_asin.c"
        "${PROJECT_SRC}/src/e_asinf.c"
        "${PROJECT_SRC}/src/e_atan2.c"
        "${PROJECT_SRC}/src/e_atan2f.c"
        "${PROJECT_SRC}/src/e_atanh.c"
        "${PROJECT_SRC}/src/e_atanhf.c"
        "${PROJECT_SRC}/src/e_cosh.c"
        "${PROJECT_SRC}/src/e_coshf.c"
        "${PROJECT_SRC}/src/e_exp.c"
        "${PROJECT_SRC}/src/e_expf.c"
        "${PROJECT_SRC}/src/e_fmod.c"
        "${PROJECT_SRC}/src/e_fmodf.c"
        "${PROJECT_SRC}/src/e_hypot.c"
        "${PROJECT_SRC}/src/e_hypotf.c"
        "${PROJECT_SRC}/src/e_j0.c"
        "${PROJECT_SRC}/src/e_j0f.c"
        "${PROJECT_SRC}/src/e_j1.c"
        "${PROJECT_SRC}/src/e_j1f.c"
        "${PROJECT_SRC}/src/e_jn.c"
        "${PROJECT_SRC}/src/e_jnf.c"
        "${PROJECT_SRC}/src/e_lgamma.c"
        "${PROJECT_SRC}/src/e_lgamma_r.c"
        "${PROJECT_SRC}/src/e_lgammaf.c"
        "${PROJECT_SRC}/src/e_lgammaf_r.c"
        "${PROJECT_SRC}/src/e_log.c"
        "${PROJECT_SRC}/src/e_log10.c"
        "${PROJECT_SRC}/src/e_log10f.c"
        "${PROJECT_SRC}/src/e_log2.c"
        "${PROJECT_SRC}/src/e_log2f.c"
        "${PROJECT_SRC}/src/e_logf.c"
        "${PROJECT_SRC}/src/e_pow.c"
        "${PROJECT_SRC}/src/e_powf.c"
        "${PROJECT_SRC}/src/e_remainder.c"
        "${PROJECT_SRC}/src/e_remainderf.c"
        "${PROJECT_SRC}/src/e_rem_pio2.c"
        "${PROJECT_SRC}/src/e_rem_pio2f.c"
        "${PROJECT_SRC}/src/e_sinh.c"
        "${PROJECT_SRC}/src/e_sinhf.c"
        "${PROJECT_SRC}/src/e_sqrt.c"
        "${PROJECT_SRC}/src/e_sqrtf.c"
        "${PROJECT_SRC}/src/k_cos.c"
        "${PROJECT_SRC}/src/k_exp.c"
        "${PROJECT_SRC}/src/k_expf.c"
        "${PROJECT_SRC}/src/k_rem_pio2.c"
        "${PROJECT_SRC}/src/k_sin.c"
        "${PROJECT_SRC}/src/k_tan.c"
        "${PROJECT_SRC}/src/k_cosf.c"
        "${PROJECT_SRC}/src/k_sinf.c"
        "${PROJECT_SRC}/src/k_tanf.c"
        "${PROJECT_SRC}/src/s_asinh.c"
        "${PROJECT_SRC}/src/s_asinhf.c"
        "${PROJECT_SRC}/src/s_atan.c"
        "${PROJECT_SRC}/src/s_atanf.c"
        "${PROJECT_SRC}/src/s_carg.c"
        "${PROJECT_SRC}/src/s_cargf.c"
        "${PROJECT_SRC}/src/s_cbrt.c"
        "${PROJECT_SRC}/src/s_cbrtf.c"
        "${PROJECT_SRC}/src/s_ceil.c"
        "${PROJECT_SRC}/src/s_ceilf.c"
        "${PROJECT_SRC}/src/s_copysign.c"
        "${PROJECT_SRC}/src/s_copysignf.c"
        "${PROJECT_SRC}/src/s_cos.c"
        "${PROJECT_SRC}/src/s_cosf.c"
        "${PROJECT_SRC}/src/s_csqrt.c"
        "${PROJECT_SRC}/src/s_csqrtf.c"
        "${PROJECT_SRC}/src/s_erf.c"
        "${PROJECT_SRC}/src/s_erff.c"
        "${PROJECT_SRC}/src/s_exp2.c"
        "${PROJECT_SRC}/src/s_exp2f.c"
        "${PROJECT_SRC}/src/s_expm1.c"
        "${PROJECT_SRC}/src/s_expm1f.c"
        "${PROJECT_SRC}/src/s_fabs.c"
        "${PROJECT_SRC}/src/s_fabsf.c"
        "${PROJECT_SRC}/src/s_fdim.c"
        "${PROJECT_SRC}/src/s_floor.c"
        "${PROJECT_SRC}/src/s_floorf.c"
        "${PROJECT_SRC}/src/s_fmax.c"
        "${PROJECT_SRC}/src/s_fmaxf.c"
        "${PROJECT_SRC}/src/s_fmin.c"
        "${PROJECT_SRC}/src/s_fminf.c"
        "${PROJECT_SRC}/src/s_fpclassify.c"
        "${PROJECT_SRC}/src/s_frexp.c"
        "${PROJECT_SRC}/src/s_frexpf.c"
        "${PROJECT_SRC}/src/s_ilogb.c"
        "${PROJECT_SRC}/src/s_ilogbf.c"
        "${PROJECT_SRC}/src/s_isinf.c"
        "${PROJECT_SRC}/src/s_isfinite.c"
        "${PROJECT_SRC}/src/s_isnormal.c"
        "${PROJECT_SRC}/src/s_isnan.c"
        "${PROJECT_SRC}/src/s_log1p.c"
        "${PROJECT_SRC}/src/s_log1pf.c"
        "${PROJECT_SRC}/src/s_logb.c"
        "${PROJECT_SRC}/src/s_logbf.c"
        "${PROJECT_SRC}/src/s_modf.c"
        "${PROJECT_SRC}/src/s_modff.c"
        "${PROJECT_SRC}/src/s_nextafter.c"
        "${PROJECT_SRC}/src/s_nextafterf.c"
        "${PROJECT_SRC}/src/s_nexttowardf.c"
        "${PROJECT_SRC}/src/s_remquo.c"
        "${PROJECT_SRC}/src/s_remquof.c"
        "${PROJECT_SRC}/src/s_rint.c"
        "${PROJECT_SRC}/src/s_rintf.c"
        "${PROJECT_SRC}/src/s_round.c"
        "${PROJECT_SRC}/src/s_roundf.c"
        "${PROJECT_SRC}/src/s_scalbln.c"
        "${PROJECT_SRC}/src/s_scalbn.c"
        "${PROJECT_SRC}/src/s_scalbnf.c"
        "${PROJECT_SRC}/src/s_signbit.c"
        "${PROJECT_SRC}/src/s_signgam.c"
        "${PROJECT_SRC}/src/s_sin.c"
        "${PROJECT_SRC}/src/s_sincos.c"
        "${PROJECT_SRC}/src/s_sinf.c"
        "${PROJECT_SRC}/src/s_sincosf.c"
        "${PROJECT_SRC}/src/s_tan.c"
        "${PROJECT_SRC}/src/s_tanf.c"
        "${PROJECT_SRC}/src/s_tanh.c"
        "${PROJECT_SRC}/src/s_tanhf.c"
        "${PROJECT_SRC}/src/s_tgammaf.c"
        "${PROJECT_SRC}/src/s_trunc.c"
        "${PROJECT_SRC}/src/s_truncf.c"
        "${PROJECT_SRC}/src/s_cpow.c"
        "${PROJECT_SRC}/src/s_cpowf.c"
        "${PROJECT_SRC}/src/w_cabs.c"
        "${PROJECT_SRC}/src/w_cabsf.c"

        "${PROJECT_SRC}/src/s_fma.c"
        "${PROJECT_SRC}/src/s_fmaf.c"
        "${PROJECT_SRC}/src/s_lrint.c"
        "${PROJECT_SRC}/src/s_lrintf.c"
        "${PROJECT_SRC}/src/s_lround.c"
        "${PROJECT_SRC}/src/s_lroundf.c"
        "${PROJECT_SRC}/src/s_llrint.c"
        "${PROJECT_SRC}/src/s_llrintf.c"
        "${PROJECT_SRC}/src/s_llround.c"
        "${PROJECT_SRC}/src/s_llroundf.c"
        "${PROJECT_SRC}/src/s_nearbyint.c"

        # C99 complex functions
        "${PROJECT_SRC}/src/s_ccosh.c"
        "${PROJECT_SRC}/src/s_ccoshf.c"
        "${PROJECT_SRC}/src/s_cexp.c"
        "${PROJECT_SRC}/src/s_cexpf.c"
	    "${PROJECT_SRC}/src/s_cimag.c"
        "${PROJECT_SRC}/src/s_cimagf.c"
        "${PROJECT_SRC}/src/s_conj.c"
        "${PROJECT_SRC}/src/s_conjf.c"
	    "${PROJECT_SRC}/src/s_cproj.c"
        "${PROJECT_SRC}/src/s_cprojf.c"
        "${PROJECT_SRC}/src/s_creal.c"
        "${PROJECT_SRC}/src/s_crealf.c"
	    "${PROJECT_SRC}/src/s_csinh.c"
        "${PROJECT_SRC}/src/s_csinhf.c"
        "${PROJECT_SRC}/src/s_ctanh.c"
        "${PROJECT_SRC}/src/s_ctanhf.c"
        "${PROJECT_SRC}/src/s_cacos.c"
        "${PROJECT_SRC}/src/s_cacosf.c"
        "${PROJECT_SRC}/src/s_cacosh.c"
        "${PROJECT_SRC}/src/s_cacoshf.c"
        "${PROJECT_SRC}/src/s_casin.c"
        "${PROJECT_SRC}/src/s_casinf.c"
        "${PROJECT_SRC}/src/s_casinh.c"
        "${PROJECT_SRC}/src/s_casinhf.c"
        "${PROJECT_SRC}/src/s_catan.c"
        "${PROJECT_SRC}/src/s_catanf.c"
        "${PROJECT_SRC}/src/s_catanh.c"
        "${PROJECT_SRC}/src/s_catanhf.c"
        "${PROJECT_SRC}/src/s_clog.c"
        "${PROJECT_SRC}/src/s_clogf.c"

        # bsdsrc
		"${PROJECT_SRC}/bsdsrc/b_exp.c"
		"${PROJECT_SRC}/bsdsrc/b_log.c"
		"${PROJECT_SRC}/bsdsrc/b_tgamma.c"
)

if(NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    list(APPEND OPENLIBM_C_SOURCE
            "${PROJECT_SRC}/src/s_nan.c"
    )
endif()

# Determine if long double and double are the same size
include(CheckCSourceCompiles)
check_c_source_compiles("
#include <float.h>
#if (LDBL_MANT_DIG == DBL_MANT_DIG)
#error \"long double and double are the same size\"
#endif
int main(void ) { return 0; }
" LONG_DOUBLE_NOT_DOUBLE)

# Add in long double functions for x86, x64 and aarch64
if(LONG_DOUBLE_NOT_DOUBLE)
    list(APPEND OPENLIBM_C_SOURCE
            "${PROJECT_SRC}/src/s_copysignl.c"
            "${PROJECT_SRC}/src/s_fabsl.c"
            "${PROJECT_SRC}/src/s_llrintl.c"
            "${PROJECT_SRC}/src/s_lrintl.c"
            "${PROJECT_SRC}/src/s_modfl.c"

            "${PROJECT_SRC}/src/e_acosl.c"
            "${PROJECT_SRC}/src/e_asinl.c"
            "${PROJECT_SRC}/src/e_atan2l.c"
            "${PROJECT_SRC}/src/e_fmodl.c"
	        "${PROJECT_SRC}/src/s_fmaxl.c"
            "${PROJECT_SRC}/src/s_fminl.c"
            "${PROJECT_SRC}/src/s_ilogbl.c"
	        "${PROJECT_SRC}/src/e_hypotl.c"
            "${PROJECT_SRC}/src/e_lgammal.c"
            "${PROJECT_SRC}/src/e_remainderl.c"
            "${PROJECT_SRC}/src/e_sqrtl.c"
	        "${PROJECT_SRC}/src/s_atanl.c"
            "${PROJECT_SRC}/src/s_ceill.c"
            "${PROJECT_SRC}/src/s_cosl.c"
            "${PROJECT_SRC}/src/s_cprojl.c"
	        "${PROJECT_SRC}/src/s_csqrtl.c"
            "${PROJECT_SRC}/src/s_floorl.c"
            "${PROJECT_SRC}/src/s_fmal.c"
	        "${PROJECT_SRC}/src/s_frexpl.c"
            "${PROJECT_SRC}/src/s_logbl.c"
            "${PROJECT_SRC}/src/s_nexttoward.c"
	        "${PROJECT_SRC}/src/s_remquol.c"
            "${PROJECT_SRC}/src/s_roundl.c"
            "${PROJECT_SRC}/src/s_lroundl.c"
            "${PROJECT_SRC}/src/s_llroundl.c"
	        "${PROJECT_SRC}/src/s_cpowl.c"
            "${PROJECT_SRC}/src/s_cargl.c"
	        "${PROJECT_SRC}/src/s_sinl.c"
            "${PROJECT_SRC}/src/s_sincosl.c"
            "${PROJECT_SRC}/src/s_tanl.c"
            "${PROJECT_SRC}/src/s_truncl.c"
            "${PROJECT_SRC}/src/w_cabsl.c"
	        "${PROJECT_SRC}/src/s_nextafterl.c"
            "${PROJECT_SRC}/src/s_rintl.c"
            "${PROJECT_SRC}/src/s_scalbnl.c"
            "${PROJECT_SRC}/src/polevll.c"
	        "${PROJECT_SRC}/src/s_casinl.c"
            "${PROJECT_SRC}/src/s_ctanl.c"
	        "${PROJECT_SRC}/src/s_cimagl.c"

=== PKGBUILD ===
# Maintainer: Peter Budai <peterbud@hotmail.com>

_realname=openlibm
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.8.6
pkgrel=3
pkgdesc="High quality system independent, portable, open source libm implementation (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
msys2_repository_url='https://github.com/JuliaMath/openlibm'
url='https://openlibm.org'
license=('spdx:MIT')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc")
source=("${_realname}-${pkgver}.tar.gz::https://github.com/JuliaMath/${_realname}/archive/v${pkgver}.tar.gz"
        "0001-openlibm-fix-pkgconfig-file.patch"
        "0002-fix-aarch64-build.patch")
sha256sums=('347998968cfeb2f9b91de6a8e85d2ba92dec0915d53500a4bc483e056f85b94c'
            'e3f2974f26d1ea5b548b153408959f3f53ab5d920dec6b94fb69e75654a635f7'
            '4bf23668a2f5865fa2d2421f85f7df35bf096bb131427bca15fb4cf4ea162c75')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Nbp1 -i "${srcdir}/$_patch"
  done
}

del_file_exists() {
  for _fname in "$@"
  do
    if [ -f $_fname ]; then
      rm -rf $_fname
    fi
  done
}
# =========================================== #

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  apply_patch_with_msg \
    0001-openlibm-fix-pkgconfig-file.patch \
    0002-fix-aarch64-build.patch
}

build() {
  cp -rf "${_realname}-${pkgver}" "build-${MSYSTEM}"

  cd "${srcdir}/build-${MSYSTEM}"
  local _compilersetting="USEGCC=1"
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _compilersetting="USECLANG=1 USEGCC=0"
  fi

  make prefix=${MINGW_PREFIX} ${_compilersetting}
}

check() {
  local _compilersetting="USEGCC=1"
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _compilersetting="USECLANG=1 USEGCC=0"
  fi

  cd "${srcdir}"/build-${MSYSTEM}
  make test ${_compilersetting}
}

package() {
  local _compilersetting="USEGCC=1"
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _compilersetting="USECLANG=1 USEGCC=0"
  fi

  cd "${srcdir}"/build-${MSYSTEM}
  make prefix=${MINGW_PREFIX} DESTDIR="${pkgdir}" install ${_compilersetting}

  install -Dm644 "${srcdir}"/build-${MSYSTEM}/LICENSE.md "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
